"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _WSClient = require("./WSClient");

var _WSClient2 = _interopRequireDefault(_WSClient);

var _events = require("../utils/events");

var _events2 = _interopRequireDefault(_events);

var _doubleApi2 = require("../doubleApi");

var _doubleApi3 = _interopRequireDefault(_doubleApi2);

var _const = require("../const");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BlankClient = function (_EventEmitter) {
    _inherits(BlankClient, _EventEmitter);

    function BlankClient() {
        var blankUri = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
        var ws = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

        _classCallCheck(this, BlankClient);

        var _this = _possibleConstructorReturn(this, (BlankClient.__proto__ || Object.getPrototypeOf(BlankClient)).call(this));

        _this._blankUri = process.env.WS || blankUri || location.protocol + "//" + location.host + location.pathname;
        if (_this._blankUri[_this._blankUri.length - 1] !== "/") {
            _this._blankUri += "/";
        }
        _this._wsClient = new _WSClient2.default();
        _this._wsClient.onopen = _this.__onWSOpen.bind(_this);
        _this._wsClient.onerror = _this.__onWSError.bind(_this);
        _this._wsClient.onclose = _this.__onWSClose.bind(_this);
        _this._ws = ws;
        _this.state = _const.CLIENT_STATES.authorization;

        _this.init = function () {
            _this.emit("init");
            return _this.getTokenInfo().then(function (res) {
                if (res) {
                    _this.__openWS();
                }
            });
        };

        _this.call = _this._wsClient.call;
        _this.subscribe = _this._wsClient.subscribe;
        _this.unsubscribe = _this._wsClient.unsubscribe;
        return _this;
    }

    _createClass(BlankClient, [{
        key: "getTokenInfo",
        value: function getTokenInfo() {
            var _this2 = this;

            if (this._user) {
                return Promise.resolve(this._user);
            }

            return this.__checkAccessToken().then(function () {
                return _this2._user;
            });
        }
    }, {
        key: "signIn",
        value: function signIn(props, _cb) {
            var _this3 = this;

            var _doubleApi = (0, _doubleApi3.default)(_cb),
                promise = _doubleApi.promise,
                cb = _doubleApi.cb;

            this._accessToken = null;

            var formData = new FormData();
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = Object.keys(props)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var propName = _step.value;

                    formData.append(propName, props[propName]);
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            var response = void 0;
            fetch(this._blankUri + "login", {
                method: "POST",
                body: formData,
                credentials: "include"
            }).then(function (_response) {
                response = _response;
                return response.json();
            }).then(function (data) {
                if (response.status !== 200) {
                    var error = new Error(data);
                    error.response = response;
                    throw error;
                }

                _this3._user = data.user;
                localStorage.setItem("signedIn", true);
                cb(null, data.user);
                _this3._ws ? _this3.__openWS() : _this3.__setState(_const.CLIENT_STATES.ready);
            }).catch(function (err) {
                console.log("SIGN IN ERROR");
                _this3.__setState(_const.CLIENT_STATES.unauthorized);
                cb(err, null);
            });

            return promise;
        }
    }, {
        key: "signOut",
        value: function signOut() {
            var _this4 = this;

            var response = void 0;
            return fetch(this._blankUri + "logout", { method: "POST", credentials: "include" }).then(function (res) {
                response = res;
                return res.json();
            }).then(function (res) {
                if (response.status !== 200) {
                    var error = new Error(res);
                    error.response = response;
                    throw error;
                }

                _this4.__reset();
            }).catch(function (err) {
                console.log("SIGN OUT ERROR", err);
            });
        }
    }, {
        key: "__openWS",
        value: function __openWS() {
            this.__setState(_const.CLIENT_STATES.wsConnecting);
            var uri = this._blankUri.replace(/^http/, "ws") + "wamp";
            this._wsClient.open(uri);
        }
    }, {
        key: "__checkAccessToken",
        value: function __checkAccessToken() {
            var _this5 = this;

            return fetch(this._blankUri + "check-jwt", {
                method: "POST",
                credentials: "include"
            }).then(function (res) {
                if (res.status !== 200) {
                    _this5.__reset();
                    return;
                }

                return res.json();
            }).then(function (res) {
                if (!res || !res.valid) {
                    return;
                }

                _this5._user = res.user;
                return res.user;
            });
        }
    }, {
        key: "__setState",
        value: function __setState(state) {
            var prev = this.state;
            this.state = state;
            try {
                this.emit("change", state, prev);
            } catch (err) {
                console.error("__setState error", err);
            }
        }
    }, {
        key: "__setToken",
        value: function __setToken(token) {
            if (token) {
                this._ws ? this.__openWS() : this.__setState(_const.CLIENT_STATES.ready);
            } else {
                this.__setState(_const.CLIENT_STATES.unauthorized);
            }
        }
    }, {
        key: "__reset",
        value: function __reset() {
            localStorage.removeItem("signedIn", true);
            this.__setState(_const.CLIENT_STATES.unauthorized);
            this._wsClient.close();
        }
    }, {
        key: "__onWSOpen",
        value: function __onWSOpen() {
            console.log("WS CONNECTED");
            // this.emit("wsopen");
            this.__setState(_const.CLIENT_STATES.wsConnected);
        }
    }, {
        key: "__onWSError",
        value: function __onWSError(e) {
            console.log("WS ERROR:", e);
            this.__checkAccessToken();
            // this.emit("wserror", e);
        }
    }, {
        key: "__onWSClose",
        value: function __onWSClose() {
            console.log("WS CLOSE");
            if (this.state === _const.CLIENT_STATES.wsConnected) {
                this.__setState(_const.CLIENT_STATES.wsConnecting);
            }
            // this.emit("wsclose", e);
        }
    }]);

    return BlankClient;
}(_events2.default);

exports.default = BlankClient;