"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _doubleApi3 = require("../doubleApi");

var _doubleApi4 = _interopRequireDefault(_doubleApi3);

var _BaseTokenProvider2 = require("./BaseTokenProvider");

var _BaseTokenProvider3 = _interopRequireDefault(_BaseTokenProvider2);

var _jwt = require("../jwt");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TOKEN_COOKIE_NAME = "blank-token";

var CookieTokenProvider = function (_BaseTokenProvider) {
    _inherits(CookieTokenProvider, _BaseTokenProvider);

    function CookieTokenProvider() {
        _classCallCheck(this, CookieTokenProvider);

        return _possibleConstructorReturn(this, (CookieTokenProvider.__proto__ || Object.getPrototypeOf(CookieTokenProvider)).call(this));
    }

    _createClass(CookieTokenProvider, [{
        key: "canIUse",
        value: function canIUse() {
            return (/^((?!chrome|android).)*safari/i.test(navigator.userAgent)
            );
        }
    }, {
        key: "get",
        value: function get(_cb) {
            var _doubleApi = (0, _doubleApi4.default)(_cb),
                promise = _doubleApi.promise,
                cb = _doubleApi.cb;

            var token = readCookie(TOKEN_COOKIE_NAME);
            if (this.__isValidToken(token)) {
                cb(null, token);
            } else {
                console.log("Invalid token in cookie, will be cleared");
                eraseCookie(TOKEN_COOKIE_NAME);
                cb(null, null);
            }
            return promise;
        }
    }, {
        key: "set",
        value: function set(token, _cb) {
            var _doubleApi2 = (0, _doubleApi4.default)(_cb),
                promise = _doubleApi2.promise,
                cb = _doubleApi2.cb;

            if (token) {
                var info = (0, _jwt.decodeToken)(token);
                createCookie(TOKEN_COOKIE_NAME, token, info.exp);
            } else {
                eraseCookie(TOKEN_COOKIE_NAME);
            }
            cb(null);
            return promise;
        }
    }]);

    return CookieTokenProvider;
}(_BaseTokenProvider3.default);

exports.default = CookieTokenProvider;


function createCookie(name, value, expiresIn) {
    var cookie = name + "=" + value,
        deleting = expiresIn === -1,
        expires = "";
    if (expiresIn) {
        expires = "; expires=" + new Date(deleting ? 0 : expiresIn * 1000).toGMTString();
    }

    var hostname = document.location.hostname.split(".");
    for (var i = hostname.length - 1; i >= 0; i--) {
        var h = hostname.slice(i).join(".");
        document.cookie = "" + cookie + expires + "; path=/; domain=." + h + ";";
        if (!deleting && document.cookie.indexOf(cookie) > -1) {
            return;
        }
    }
}

function readCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(";");
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == " ") {
            c = c.substring(1, c.length);
        }if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
    }
    return null;
}

function eraseCookie(name) {
    createCookie(name, "", -1);
}