"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _doubleApi3 = require("../doubleApi");

var _doubleApi4 = _interopRequireDefault(_doubleApi3);

var _BaseTokenProvider2 = require("./BaseTokenProvider");

var _BaseTokenProvider3 = _interopRequireDefault(_BaseTokenProvider2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IframeTokenProvider = function (_BaseTokenProvider) {
    _inherits(IframeTokenProvider, _BaseTokenProvider);

    function IframeTokenProvider(uri) {
        _classCallCheck(this, IframeTokenProvider);

        var _this = _possibleConstructorReturn(this, (IframeTokenProvider.__proto__ || Object.getPrototypeOf(IframeTokenProvider)).call(this));

        _this._mID = 0;
        _this._blankUri = uri;
        _this._requests = {};
        var loadFramePromise = new Promise(function (resolve) {
            _this.__prepareFrame(resolve);
        });
        _this._waitForLoad = function () {
            return loadFramePromise;
        };
        return _this;
    }

    _createClass(IframeTokenProvider, [{
        key: "canIUse",
        value: function canIUse() {
            return !/^((?!chrome|android).)*safari/i.test(navigator.userAgent);
        }
    }, {
        key: "get",
        value: function get(_cb) {
            var _this2 = this;

            var _doubleApi = (0, _doubleApi4.default)(_cb),
                promise = _doubleApi.promise,
                cb = _doubleApi.cb;

            this._waitForLoad().then(function () {
                return _this2.__rpc({ method: "GET" });
            }).then(function (token) {
                if (_this2.__isValidToken(token)) {
                    cb(null, token);
                } else {
                    console.log("Invalid token in iframe storage, will be cleared");
                    _this2.__rpc({ method: "REMOVE" });
                    cb(null, null);
                }
            });
            return promise;
        }
    }, {
        key: "set",
        value: function set(token, _cb) {
            var _this3 = this;

            var _doubleApi2 = (0, _doubleApi4.default)(_cb),
                promise = _doubleApi2.promise,
                cb = _doubleApi2.cb;

            this._waitForLoad().then(function () {
                return _this3.__rpc({ method: "SET", token: token });
            }).then(function () {
                cb(null, null);
            });
            return promise;
        }
    }, {
        key: "__getMessageId",
        value: function __getMessageId() {
            return "a" + ++this._mID;
        }
    }, {
        key: "__rpc",
        value: function __rpc(data) {
            var _this4 = this;

            return new Promise(function (resolve, reject) {
                data.id = _this4.__getMessageId();
                var timer = setTimeout(function () {
                    reject("Iframe RPC timeout");
                }, 2000);
                _this4._requests[data.id] = function (_d) {
                    clearTimeout(timer);
                    delete _this4._requests[data.id];
                    resolve(_d);
                };
                _this4.iframeWindow.postMessage(data, _this4._blankUri);
            });
        }
    }, {
        key: "__prepareFrame",
        value: function __prepareFrame(_cb) {
            var _this5 = this;

            var frame = document.createElement("iframe");
            frame.style.width = "0";
            frame.style.height = "0";
            frame.setAttribute("src", this._blankUri + "hooks/cd/frame");
            frame.addEventListener("load", function () {
                _this5.iframeWindow = frame.contentWindow;
                _this5.iframeWindow.postMessage({ method: "SUBSCRIBE", id: _this5.__getMessageId() }, _this5._blankUri);
                _cb();
            });
            window.addEventListener("message", function (event) {
                // console.log("EVENT:", event.origin, event.data);
                if (_this5._blankUri.indexOf(event.origin) !== 0 || event.data == null) {
                    return;
                }

                if (event.data.requestId) {
                    var requestCb = _this5._requests[event.data.requestId];
                    if (typeof requestCb === "function") {
                        requestCb(event.data.result);
                    }
                } else {
                    if (typeof event.data.token !== "undefined") {
                        _this5.emit("change", event.data.token);
                    }
                }
            }, false);
            document.body.appendChild(frame);
        }
    }]);

    return IframeTokenProvider;
}(_BaseTokenProvider3.default);

exports.default = IframeTokenProvider;