"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _doubleApi3 = require("../doubleApi");

var _doubleApi4 = _interopRequireDefault(_doubleApi3);

var _const = require("../const");

var _BaseTokenProvider2 = require("./BaseTokenProvider");

var _BaseTokenProvider3 = _interopRequireDefault(_BaseTokenProvider2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LsTokenProvider = function (_BaseTokenProvider) {
    _inherits(LsTokenProvider, _BaseTokenProvider);

    function LsTokenProvider(uri) {
        _classCallCheck(this, LsTokenProvider);

        var _this = _possibleConstructorReturn(this, (LsTokenProvider.__proto__ || Object.getPrototypeOf(LsTokenProvider)).call(this));

        _this._blankUri = uri;
        window.addEventListener("storage", function (e) {
            if (e.key === _const.TOKEN_LS_KEY) {
                _this.emit("change", localStorage.getItem(_const.TOKEN_LS_KEY));
            }
        });
        return _this;
    }

    _createClass(LsTokenProvider, [{
        key: "canIUse",
        value: function canIUse() {
            return this.__isSameOrigin(this._blankUri) && !/^((?!chrome|android).)*safari/i.test(navigator.userAgent);
        }
    }, {
        key: "__isSameOrigin",
        value: function __isSameOrigin(url) {
            if (!url) {
                return true;
            }
            var loc = window.location,
                a = document.createElement("a");
            a.href = url;
            return a.hostname == loc.hostname && a.port == loc.port && a.protocol == loc.protocol;
        }
    }, {
        key: "get",
        value: function get(_cb) {
            var _doubleApi = (0, _doubleApi4.default)(_cb),
                promise = _doubleApi.promise,
                cb = _doubleApi.cb;

            var token = localStorage.getItem(_const.TOKEN_LS_KEY) || null;
            if (this.__isValidToken(token)) {
                cb(null, token);
            } else {
                console.log("Invalid token in localStorage, will be cleared");
                localStorage.removeItem(_const.TOKEN_LS_KEY);
                cb(null, null);
            }
            return promise;
        }
    }, {
        key: "set",
        value: function set(token, _cb) {
            var _doubleApi2 = (0, _doubleApi4.default)(_cb),
                promise = _doubleApi2.promise,
                cb = _doubleApi2.cb;

            if (token) {
                localStorage.setItem(_const.TOKEN_LS_KEY, token);
            } else {
                localStorage.removeItem(_const.TOKEN_LS_KEY);
            }
            cb(null);
            return promise;
        }
    }]);

    return LsTokenProvider;
}(_BaseTokenProvider3.default);

exports.default = LsTokenProvider;