"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Created by kib357 on 15/02/16.
 */

var EventEmitter = function () {
    function EventEmitter() {
        _classCallCheck(this, EventEmitter);

        this._events = new Map();
    }

    _createClass(EventEmitter, [{
        key: "on",
        value: function on(eventType, handler) {
            if (!this._events.has(eventType)) {
                this._events.set(eventType, new Set());
            }
            var handlers = this._events.get(eventType);
            handlers.add(handler);
        }
    }, {
        key: "addEventListener",
        value: function addEventListener(eventType, handler) {
            return this.on(eventType, handler);
        }
    }, {
        key: "removeListener",
        value: function removeListener(eventType, handler) {
            if (!this._events.has(eventType)) {
                return;
            }
            var handlers = this._events.get(eventType);
            handlers.delete(handler);
        }
    }, {
        key: "emit",
        value: function emit(eventType) {
            if (!this._events.has(eventType)) {
                return;
            }
            var handlers = this._events.get(eventType);
            var len = arguments.length;
            if (len === 1) {
                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    for (var _iterator = handlers[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        var handler = _step.value;

                        handler.call(this);
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            } else {
                var args = new Array(len - 1);
                for (var i = 1; i < len; i++) {
                    args[i - 1] = arguments[i];
                }
                var _iteratorNormalCompletion2 = true;
                var _didIteratorError2 = false;
                var _iteratorError2 = undefined;

                try {
                    for (var _iterator2 = handlers[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                        var _handler = _step2.value;

                        _handler.apply(this, Array.prototype.slice.call(args));
                    }
                } catch (err) {
                    _didIteratorError2 = true;
                    _iteratorError2 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                            _iterator2.return();
                        }
                    } finally {
                        if (_didIteratorError2) {
                            throw _iteratorError2;
                        }
                    }
                }
            }
        }
    }]);

    return EventEmitter;
}();

exports.default = EventEmitter;